<div class="container-fluid">
  <div class="col-md-12">
    <div class="box">
      <div class="box-header with-border">
        <div class="row">
          <div class="col-sm-5">
            <h3 class="box-title">Rent Payments</h3>
          </div>
          <div class="col-sm-3 fa-pull-right">
            <button class="btn btn-success btn-xs mx-2"
                    (click)="downloadSampleDocument()">
              <i class="pi pi-file-excel" style="font-size: 1em;"></i>
              Generate Report
            </button>
          </div>
          <!--            <button class="btn btn-success btn-xs mx-2"-->
          <!--                    (click)="downloadSampleData()">-->
          <!--              <i class="pi pi-file-excel" style="font-size: 1em;"></i>-->
          <!--              Sample Data-->
          <!--            </button>-->
          <!--            <button class="btn btn-success btn-xs mx-2"-->
          <!--                    (click)="clearDetail()">-->
          <!--              <span *ngIf="clearDataLoading" class="spinner-border spinner-border-sm mr-1"></span>-->
          <!--              Clear Data-->
          <!--            </button>-->
          <!--          </div>-->
          <!--          <div class="col-sm-4">-->
          <!--            <form [formGroup]="myForm" (ngSubmit)="submit()" class="fa-pull-right">-->
          <!--              <input-->
          <!--                style="width: 190px;"-->
          <!--                formControlName="file"-->
          <!--                id="file"-->
          <!--                [ngClass]="{ 'is-invalid': submitted && f.file.errors }"-->
          <!--                type="file"-->
          <!--                (change)="onFileChange($event)">-->
          <!--              <button class="btn btn-success btn-xs"-->
          <!--                      [disabled]="loading"-->
          <!--                      type="submit">-->
          <!--                <span *ngIf="loading" class="spinner-border spinner-border-sm mx-2"></span>-->
          <!--                Submit-->
          <!--              </button>-->
          <!--              <button class="btn btn-danger btn-xs mx-2"-->
          <!--                      (click)="resetForm()"-->
          <!--                      type="submit">-->
          <!--                Reset-->
          <!--              </button>-->
          <!--              <div *ngIf="submitted && f.file.errors" class="invalid-feedback"-->
          <!--                   style="width: 210px;">-->
          <!--                <div *ngIf="f.file.errors.required">File is required</div>-->
          <!--              </div>-->
          <!--            </form>-->
          <!--          </div>-->
        </div>
      </div>
      <!-- /.box-header -->
      <div class="box-body">
        <p-table id="exportTable"
                 class="text-left"
                 [columns]="columnName"
                 [value]="(data$)"
                 [resizableColumns]="true"
                 [autoLayout]="true">
          <ng-template pTemplate="caption">
            <div class="row">
              <div class="col-sm-3">
                <span class="fa-pull-left">
                    List of Rent Payment Details
                :&nbsp;{{ totalRecords }}
                </span>
              </div>
              <div class="col-sm-3" *ngIf="totalRecords > 0">
                <button class="btn btn-success btn-xs fa-pull-right"
                        type="submit"
                        [routerLink]="['/rent/create-payment',rentPaymentId ]"
                >
                  <i class=" pi pi-arrow-circle-right"></i>
                  Process For Payment
                </button>
              </div>
              <div class="col-sm-6">
                <button class="btn btn-success btn-xs fa-pull-right"
                        type="submit"
                        (click)="addEditNewRentPaymentDetail('Add', null)"
                >
                  Add New Periodic Payment
                </button>
              </div>
            </div>
          </ng-template>
          <ng-template pTemplate="header" let-columns>
            <tr>
              <th *ngFor="let col of columns" [pSortableColumn]="col.value">
                {{col.name}}
                <p-sortIcon [field]="col.value"></p-sortIcon>
              </th>
            </tr>
          </ng-template>

          <ng-template pTemplate="body" let-list let-i="rowIndex">
            <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
              <td>{{ i + 1 + page * itemsPerPage}}</td>
              <td>{{ list.created | date: 'short' }}</td>
              <td>{{ list.debitBranch}}</td>
              <td>{{ list.accountHead }}</td>
              <td>{{ list.creditBranch }}</td>
              <td>{{ list.creditAccountNumber }}</td>
              <td>{{ list.amount | currency: 'NPR.' }}</td>
              <td>{{ list.tdsAmount  | currency: 'NPR.'  }}</td>
              <td>{{ list.narration }}</td>
              <td>{{ list.rentFor }}</td>

              <td>
                <p-inputSwitch
                  [name]="list.status"
                  [inputId]="list.status"
                  (onChange)="handleChange($event, list.rentPaymentDetailId)"
                  [ngModel]="list.status === 'ACTIVE'? true: false ">
                </p-inputSwitch>
              </td>
              <td>
                <i class="pi pi-caret-up"
                   *ngIf="list.hasRentIncreased"
                   style="font-size: 1rem; color: red">
                </i>

                <i class="pi pi-check"
                   *ngIf="!list.hasRentIncreased"
                   style="font-size: 1rem; color: green">
                </i>
                <!--                <i class="pi caret-up"-->
                <!--                   style="font-size: 1rem">-->
                <!--                </i>-->

                <!--                {{ list.hasRentIncreased }}</td>-->
              <td>
                <a (click)="addEditNewRentPaymentDetail('Edit', list)">
                  <svg class="bi bi-pencil-square"
                       width="1em"
                       height="1em"
                       viewBox="0 0 16 16"
                       fill="currentColor"
                       xmlns="http://www.w3.org/2000/svg">
                    <path
                      d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456l-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                    <path fill-rule="evenodd"
                          d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                  </svg>
                </a>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <p-paginator
          [rows]="itemsPerPage"
          [totalRecords]="totalRecords"
          pageLinkSize="3"
          [rowsPerPageOptions]="rowsPerPageOptions"
          (onPageChange)="paginate($event)">
        </p-paginator>
      </div>
      <div class="box-footer">
      </div>
    </div>
  </div>
</div>


<p-dialog [(visible)]="display"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    {{eventType}} Rent Payment Details
  </p-header>
  <form [formGroup]="addEditRentPaymentDetailForm">
    <div class="form-group" *ngIf="eventType === 'Add'">
      <label for="rentOwners">Rent Owners<span class="required">*</span></label>
      <select id="rentOwners"
              class="form-control"
              name="rentOwners"
              [ngClass]="{ 'is-invalid': submitted && ff.rentOwnerId.errors }"
              formControlName="rentOwnerId"
              (ngModelChange)="fetchRentDetail()"
              required
      >
        <option *ngFor="let event of (rentOwners); let i = index"
                [ngValue]="(rentOwners)[i].rentOwnerId"
        >{{(rentOwners)[i].name + ' ( ' + (rentOwners)[i].address + ' )'}}
        </option>
      </select>
      <div *ngIf="submitted && ff.rentOwnerId.errors" class="invalid-feedback">
        <div *ngIf="ff.rentOwnerId.errors.required">Rent Owner is required</div>
      </div>
    </div>

    <div class="form-group" *ngIf="eventType === 'Add'">
      <label for="rentDetails">Rent Details<span class="required">*</span></label>
      <select id="rentDetails"
              class="form-control"
              name="rentDetails"
              [ngClass]="{ 'is-invalid': submitted && ff.rentDetailId.errors }"
              formControlName="rentDetailId"
              required
      >
        <option *ngFor="let event of (rentDetails); let i = index"
                [ngValue]="(rentDetails)[i].rentDetailId"
        >{{(rentDetails)[i].rentDetail + ' ( ' + (rentDetails)[i].rentDescription + ','
        + (rentDetails)[i].rentForType + ')'}}
        </option>
      </select>
      <div *ngIf="submitted && ff.rentOwnerId.errors" class="invalid-feedback">
        <div *ngIf="ff.rentOwnerId.errors.required">Rent Owner is required</div>
      </div>
    </div>

    <div class="form-group">
      <label for="debitBranch">Debit Branch<span class="required">*</span></label>
      <select id="debitBranch"
              class="form-control"
              name="debitBranch"
              [ngClass]="{ 'is-invalid': submitted && ff.debitBranchId.errors }"
              formControlName="debitBranchId"
              required
      >
        <option *ngFor="let event of (allBranch); let i = index"
                [ngValue]="(allBranch)[i].branchId"
        >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}
        </option>
      </select>
      <div *ngIf="submitted && ff.debitBranchId.errors" class="invalid-feedback">
        <div *ngIf="ff.debitBranchId.errors.required">Debit Branch is required</div>
      </div>
    </div>


    <div class="form-group">
      <label for="debitAccountHead">Debit Account Head<span class="required">*</span></label>
      <select id="debitAccountHead"
              class="form-control"
              name="debitAccountHead"
              [ngClass]="{ 'is-invalid': submitted && ff.debitAccountHeadId.errors }"
              formControlName="debitAccountHeadId"
              required
      >
        <option *ngFor="let event of (accountHeads); let i = index"
                [ngValue]="(accountHeads)[i].accountHeadId"
        >{{(accountHeads)[i].description + ' ( ' + (accountHeads)[i].code + ' )'}}
        </option>
      </select>
      <div *ngIf="submitted && ff.debitAccountHeadId.errors" class="invalid-feedback">
        <div *ngIf="ff.debitAccountHeadId.errors.required">Debit Account Head is required</div>
      </div>
    </div>

    <div class="form-group">
      <label for="creditBranch">Credit Branch<span class="required">*</span></label>
      <select id="creditBranch"
              class="form-control"
              name="creditBranch"
              [ngClass]="{ 'is-invalid': submitted && ff.creditBranchId.errors }"
              formControlName="creditBranchId"
              required
      >
        <option *ngFor="let event of (allBranch); let i = index"
                [ngValue]="(allBranch)[i].branchId"
        >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}
        </option>
      </select>
      <div *ngIf="submitted && ff.creditBranchId.errors" class="invalid-feedback">
        <div *ngIf="ff.creditBranchId.errors.required">Credit Branch is required</div>
      </div>
    </div>

    <div class="form-group">
      <label for="acNumber">Credit Account Number<span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="acNumber"
             placeholder="Enter Credit Account Number"
             formControlName="creditAccountNumber"
             [ngClass]="{ 'is-invalid': submitted && ff.creditAccountNumber.errors }"
             required
      >
      <div *ngIf="submitted && ff.creditAccountNumber.errors" class="invalid-feedback">
        <div *ngIf="ff.creditAccountNumber.errors.required">Credit Account Number is Required.</div>
      </div>
    </div>

    <div class="form-group">
      <label for="amount">Amount<span class="required">*</span></label>
      <input type="number"
             class="form-control"
             id="amount"
             placeholder="Enter Amount"
             formControlName="amount"
             [ngClass]="{ 'is-invalid': submitted && ff.amount.errors }"
             required
      >
      <span *ngIf="addEditRentPaymentDetailForm.value.amount">
        {{ this.addEditRentPaymentDetailForm.value.amount | numberToWords}}
      </span>
      <div *ngIf="submitted && ff.amount.errors" class="invalid-feedback">
        <div *ngIf="ff.amount.errors.required">Amount is Required.</div>
      </div>
    </div>

    <div class="form-group">
      <label for="tdsAmount">TDS Amount <span class="required">*</span></label>
      <input type="number"
             class="form-control"
             id="tdsAmount"
             placeholder="Enter TDS Amount"
             formControlName="tdsAmount"
             [ngClass]="{ 'is-invalid': submitted && ff.tdsAmount.errors }"
             required
      >
      <span *ngIf="addEditRentPaymentDetailForm.value.tdsAmount">
        {{ this.addEditRentPaymentDetailForm.value.tdsAmount | numberToWords}}
      </span>
      <div *ngIf="submitted && ff.tdsAmount.errors" class="invalid-feedback">
        <div *ngIf="ff.tdsAmount.errors.required">TDS Amount is Required.</div>
      </div>
    </div>

    <div class="form-group">
      <label for="narration">Narration<span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="narration"
             placeholder="Enter Narration"
             formControlName="narration"
             [ngClass]="{ 'is-invalid': submitted && ff.narration.errors }"
             required
      >
      <div *ngIf="submitted && ff.narration.errors" class="invalid-feedback">
        <div *ngIf="ff.narration.errors.required">Narration is Required.</div>
      </div>
    </div>

    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block"
                  (click)="cancel()">
            Cancel
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  [disabled]="loading"
                  (click)="submitNewRentPaymentDetail()"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>
